import type { BaseContract, BigNumber, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface IEndpointInterface extends utils.Interface {
    functions: {
        "eid()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "eid"): FunctionFragment;
    encodeFunctionData(functionFragment: "eid", values?: undefined): string;
    decodeFunctionResult(functionFragment: "eid", data: BytesLike): Result;
    events: {};
}
export interface IEndpoint extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IEndpointInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        eid(overrides?: CallOverrides): Promise<[number]>;
    };
    eid(overrides?: CallOverrides): Promise<number>;
    callStatic: {
        eid(overrides?: CallOverrides): Promise<number>;
    };
    filters: {};
    estimateGas: {
        eid(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        eid(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
